<?php 

if ( ! defined( 'ABSPATH' ) ) { 
	exit; // restict for direct access
}

if ( !class_exists( 'Admin_Class_Addify_Password_Protected_Store' ) ) {

	class Admin_Class_Addify_Password_Protected_Store extends Addify_Password_Protected_Store {

		function __construct() {

			add_action( 'admin_menu', array( $this, 'pps_custom_menu_admin' ) );
			add_action('admin_init', array($this, 'addify_password_protected_store_options'));
			add_action( 'admin_enqueue_scripts', array( $this, 'pps_admin_assets' ) );

			if(isset($_POST['add_rule']) && $_POST['add_rule']!='') {
				$this->add_rule();
			}

			if(isset($_POST['update_rule']) && $_POST['update_rule']!='') {
				$this->update_rule();
			}


			if(isset($_POST['imp_pass']) && $_POST['imp_pass']!='') {
				$this->imp_passwords();
			}

			if(isset($_POST['add_pass']) && $_POST['add_pass']!='') {
				$this->add_passwords();
			}
		}


		public function pps_custom_menu_admin() {	
			
			add_menu_page (
		        __('Password Protected Store', 'addify_pps'), // page title 
		        __('Password Protected Store', 'addify_pps'), // menu title
		        'manage_options', // capability
		        'addify-password-protected-store',  // menu-slug
		        array($this, 'pps_passwords_rules'),   // function that will render its output
		        plugins_url( 'assets/img/small_logo_white.png',  __FILE__  ),   // link to the icon that will be displayed in the sidebar
		        '7'    // position of the menu option
		    );

		    add_submenu_page( 'addify-password-protected-store', __( 'Passwords Rules', 'addify_pps' ), __( 'Passwords Rules', 'addify_pps' ), 'manage_options', 'addify-password-protected-store', array( $this, 'pps_passwords_rules' ) );

		    add_submenu_page( 'addify-password-protected-store', __( 'Add Rule', 'addify_pps' ), __( 'Add Rule', 'addify_pps' ), 'manage_options', 'pps_add_rule', array( $this, 'pps_add_rule' ) );

		    add_submenu_page( 'addify-password-protected-store', __( 'Settings', 'addify_pps' ), __( 'Settings', 'addify_pps' ), 'manage_options', 'addify-password-protected-store-settings', array( $this, 'password_protected_store_settings' ) );

		    //add_submenu_page( 'addify-password-protected-store', __( 'Passwords', 'addify_pps' ), __( 'Passwords', 'addify_pps' ), 'manage_options', 'pps_passwords', array( $this, 'pps_passwords' ) );

		    
	    }


	    public function pps_admin_assets() {

	    	wp_enqueue_style( 'addify_pps_admin_css', plugins_url( '/assets/css/addify_pps_admin_css.css', __FILE__ ), false );
	    	wp_enqueue_script( 'color_spectrum_js', plugins_url( '/assets/js/color_spectrum.js', __FILE__ ), array('jquery'), false );
	    	wp_enqueue_script( 'addify_pps_admin_js', plugins_url( '/assets/js/addify_pps_admin_js.js', __FILE__ ), array('jquery'), false );
        	wp_enqueue_style( 'color_spectrum_css', plugins_url( '/assets/css/color_spectrum.css', __FILE__ ), false );

        	wp_enqueue_style( 'thickbox' );
			wp_enqueue_script( 'thickbox' );
			wp_enqueue_script( 'media-upload' ); 
			wp_enqueue_media();

			//select2 css and js
			wp_enqueue_script('jquery');
			wp_enqueue_style( 'addify_pps-select2-css', 'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6-rc.0/css/select2.min.css', false );
			wp_enqueue_style( 'addify_pps-select2-bscss', 'https://cdnjs.cloudflare.com/ajax/libs/select2/3.5.2/select2-bootstrap.css', false );
        	wp_enqueue_script( 'addify_pps-select2-js', 'https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6-rc.0/js/select2.min.js', false);
	    }


	    public function pps_passwords_rules() {

	    	require_once( addify_pps_plugindir . 'templates/password_rules.php' );

	    }


	    public function pps_passwords() {

	    	require_once( addify_pps_plugindir . 'templates/admin_password.php' );
	    }

	    public function pps_add_rule() {

	    	require_once( addify_pps_plugindir . 'templates/pps_add_rule.php' );
	    }


	    public function password_protected_store_settings() {

	    	if( isset( $_GET[ 'tab' ] ) ) {  
	            $active_tab = $_GET[ 'tab' ];  
	        } else {
	            $active_tab = 'tab_one';
	        }
	        ?>

	        <div class="wrap">
	        	<h2><?php _e('Password Protected Store Settings', 'addify_pps'); ?></h2>

	        	<div class="description"><?php _e('Manage your password protected store settings from here!', 'addify_pps'); ?></div>
	            <?php settings_errors(); ?> 

	            <h2 class="nav-tab-wrapper">  
	                <a href="?page=addify-password-protected-store-settings&tab=tab_one" class="nav-tab <?php echo $active_tab == 'tab_one' ? 'nav-tab-active' : ''; ?>"><?php _e('General Settings', 'addify_pps'); ?></a>  
	                
            	</h2>

            	<form method="post" action="options.php"> 
		            <?php
		                if( $active_tab == 'tab_one' ) {  

		                    settings_fields( 'setting-group-1' );
		                    do_settings_sections( 'addify-password-protected-store-1' );

		                } 
		            ?>
	                <?php submit_button(); ?> 
	            </form> 


	        </div>

	        <?php
	    }



	    public function addify_password_protected_store_options() {

	    	add_settings_section(  
		        'pps_page_1_section',         // ID used to identify this section and with which to register options  
		        __('Display & Background Settings', 'addify_pps'),                  // Title to be displayed on the administration page  
		        array($this, 'pps_page_1_section_callback'), // Callback used to render the description of the section  
		        'addify-password-protected-store-1'                           // Page on which to add this section of options  

		    );

		   

		    add_settings_field (   
		        'pps_form_title',                      // ID used to identify the field throughout the theme  
		        __('Form Title', 'addify_pps'),                           // The label to the left of the option interface element  
		        array($this, 'pps_form_title_callback'),   // The name of the function responsible for rendering the option interface  
		        'addify-password-protected-store-1',                          // The page on which this option will be displayed  
		        'pps_page_1_section',         // The name of the section to which this field belongs  
		        array(                              // The array of arguments to pass to the callback. In this case, just a description.  
		            __('This form title will be shown on the password entry form on frontend.', 'addify_pps'),
		        )  
		    );  
		    register_setting(  
		        'setting-group-1',  
		        'pps_form_title'  
		    );


		    add_settings_field (   
		        'pps_background',                      // ID used to identify the field throughout the theme  
		        __('Background', 'addify_pps'),                           // The label to the left of the option interface element  
		        array($this, 'pps_background_callback'),   // The name of the function responsible for rendering the option interface  
		        'addify-password-protected-store-1',                          // The page on which this option will be displayed  
		        'pps_page_1_section',         // The name of the section to which this field belongs  
		        array(                              // The array of arguments to pass to the callback. In this case, just a description.  
		            __('This is the page background of password entry form page.', 'addify_pps'),
		        )  
		    );  
		    register_setting(  
		        'setting-group-1',  
		        'pps_background'  
		    );

		    add_settings_field (   
		        'pps_background_colour',                      // ID used to identify the field throughout the theme  
		        '<div class="pps_back_colour">'.__('Background Colour', 'addify_pps').'</div>',                           // The label to the left of the option interface element  
		        array($this, 'pps_background_colour_callback'),   // The name of the function responsible for rendering the option interface  
		        'addify-password-protected-store-1',                          // The page on which this option will be displayed  
		        'pps_page_1_section',         // The name of the section to which this field belongs  
		        array(                              // The array of arguments to pass to the callback. In this case, just a description.  
		            __('This is the background colour of password entry form page.', 'addify_pps'),
		        )  
		    );  
		    register_setting(  
		        'setting-group-1',  
		        'pps_background_colour'  
		    );


		    add_settings_field (   
		        'pps_background_image',                      // ID used to identify the field throughout the theme  
		        '<div class="pps_back_image">'.__('Background Image', 'addify_pps').'</div>',                           // The label to the left of the option interface element  
		        array($this, 'pps_background_image_callback'),   // The name of the function responsible for rendering the option interface  
		        'addify-password-protected-store-1',                          // The page on which this option will be displayed  
		        'pps_page_1_section',         // The name of the section to which this field belongs  
		        array(                              // The array of arguments to pass to the callback. In this case, just a description.  
		            __('This is the background image of password entry form page.', 'addify_pps'),
		        )  
		    );  
		    register_setting(  
		        'setting-group-1',  
		        'pps_background_image'  
		    );


		    add_settings_field (   
		        'pps_form_background_opacity',                      // ID used to identify the field throughout the theme  
		        __('Form Background Opacity', 'addify_pps'),                           // The label to the left of the option interface element  
		        array($this, 'pps_form_background_opacity_callback'),   // The name of the function responsible for rendering the option interface  
		        'addify-password-protected-store-1',                          // The page on which this option will be displayed  
		        'pps_page_1_section',         // The name of the section to which this field belongs  
		        array(                              // The array of arguments to pass to the callback. In this case, just a description.  
		            __('Please use values between 0 and 1 for example 0.4 or 0.18 etc.', 'addify_pps'),
		        )  
		    );  
		    register_setting(  
		        'setting-group-1',  
		        'pps_form_background_opacity'  
		    );



            add_settings_field (
                'pps_form_logo',                      // ID used to identify the field throughout the theme
                __('Form Logo', 'addify_pps'),                           // The label to the left of the option interface element
                array($this, 'pps_form_logo_callback'),   // The name of the function responsible for rendering the option interface
                'addify-password-protected-store-1',                          // The page on which this option will be displayed
                'pps_page_1_section',         // The name of the section to which this field belongs
                array(                              // The array of arguments to pass to the callback. In this case, just a description.
                    __('Upload Logo that you want to display on the password form.', 'addify_pps'),
                )
            );
            register_setting(
                'setting-group-1',
                'pps_form_logo'
            );



            add_settings_field (
                'pps_form_text',                      // ID used to identify the field throughout the theme
                __('Form Text', 'addify_pps'),                           // The label to the left of the option interface element
                array($this, 'pps_form_text_callback'),   // The name of the function responsible for rendering the option interface
                'addify-password-protected-store-1',                          // The page on which this option will be displayed
                'pps_page_1_section',         // The name of the section to which this field belongs
                array(                              // The array of arguments to pass to the callback. In this case, just a description.
                    __('This text will be shown on the form on frontend, you can write your instruction about password from.', 'addify_pps'),
                )
            );
            register_setting(
                'setting-group-1',
                'pps_form_text'
            );


		    

		    


		    add_settings_field (   
		        'pps_allowed_ips',                      // ID used to identify the field throughout the theme  
		        __('Allowed IPs', 'addify_pps'),                           // The label to the left of the option interface element  
		        array($this, 'pps_allowed_ips_callback'),   // The name of the function responsible for rendering the option interface  
		        'addify-password-protected-store-1',                          // The page on which this option will be displayed  
		        'pps_page_1_section',         // The name of the section to which this field belongs  
		        array(                              // The array of arguments to pass to the callback. In this case, just a description.  
		            __('Add comma(,) separated ips that you want to allowed.', 'addify_pps'),
		        )  
		    );  
		    register_setting(  
		        'setting-group-1',  
		        'pps_allowed_ips'  
		    );


		    add_settings_field (   
		        'pps_goolge',                      // ID used to identify the field throughout the theme  
		        __('Allow Google to crawl', 'addify_pps'),                           // The label to the left of the option interface element  
		        array($this, 'pps_goolge_callback'),   // The name of the function responsible for rendering the option interface  
		        'addify-password-protected-store-1',                          // The page on which this option will be displayed  
		        'pps_page_1_section',         // The name of the section to which this field belongs  
		        array(                              // The array of arguments to pass to the callback. In this case, just a description.  
		            __('Do you want Google searchbot to access the webstore for SEO?.', 'addify_pps'),
		        )  
		    );  
		    register_setting(  
		        'setting-group-1',  
		        'pps_goolge'  
		    );


            add_settings_field (
                'pps_full_hide_products',                      // ID used to identify the field throughout the theme
                __('Hide Products Completely on Shop/Archive Pages', 'addify_pps'),                           // The label to the left of the option interface element
                array($this, 'pps_full_hide_products_callback'),   // The name of the function responsible for rendering the option interface
                'addify-password-protected-store-1',                          // The page on which this option will be displayed
                'pps_page_1_section',         // The name of the section to which this field belongs
                array(                              // The array of arguments to pass to the callback. In this case, just a description.
                    __('Check this option if you want to hide products completely on shop, category and archive pages. Otherwise products will be shown with Password Protected button instead of Add to Cart and on click on that button you will be redirected to Password Form.', 'addify_pps'),
                )
            );
            register_setting(
                'setting-group-1',
                'pps_full_hide_products'
            );


	    }

	    function pps_page_1_section_callback() {  
		    echo '<p>'._e('Enter password protected store form display and background settings here.', 'addify_pps').'</p>';  
		} // function pps_page_1_section_callback

		

		function pps_form_title_callback($args) {  
		    ?>
		    <input type="text" id="pps_form_title" class="login_title" name="pps_form_title" value="<?php echo get_option('pps_form_title') ?>">
		    <p class="description pps_form_title"> <?php echo $args[0] ?> </p>
		    <?php      
		} // end pps_form_title_callback 


		function pps_background_callback($args) {  
		    ?>
		    <select id="pps_background" class="login_title" name="pps_background" onchange="showCoImg(this.value)">
		    	<option value="none" <?php echo selected('none', get_option('pps_background')); ?>><?php _e('None', 'addify_pps'); ?></option>
		    	<option value="colour" <?php echo selected('colour', get_option('pps_background')); ?>><?php _e('Colour', 'addify_pps'); ?></option>
		    	<option value="image" <?php echo selected('image', get_option('pps_background')); ?>><?php _e('Image', 'addify_pps'); ?></option>
		    </select>
		    <p class="description pps_background"> <?php echo $args[0] ?> </p>
		    <?php      
		} // end pps_background_callback 


		function pps_background_colour_callback($args) {  
		    ?>
		    <div class="pps_back_colour">
		    	<input type="text" class="login_title color_sepctrum" name="pps_background_colour" id="pps_background_colour" value="<?php echo get_option('pps_background_colour') ?>" />
		    	<p class="description pps_background_colour"> <?php echo $args[0] ?> </p>
			</div>
			<script>
				jQuery(".color_sepctrum").spectrum({
				    color: "<?php echo get_option('pps_background_colour') ?>",
				    preferredFormat: "hex",
				});
			</script>
		   
		    <?php      
		} // end pps_background_colour_callback 


		function pps_background_image_callback($args) {  
		    ?>

		    <div class="pps_back_image">
		    	<div class="imgdis" id="imgdisplay">
				
					<img src="<?php echo get_option('pps_background_image') ?>" width="200" />
				
				</div>

		    	<input type="hidden" value="<?php echo get_option('pps_background_image') ?>" name="pps_background_image" id="pps_image_url" class="login_title">
				<input onClick="pps_image()"   type="button" name="upload-btn" id="upload-btn" class="button-secondary" value="Upload">
		    	<p class="description pps_background_colour"> <?php echo $args[0] ?> </p>
			</div>

		    
		    <?php      
		} // end pps_background_image_callback







        function pps_form_logo_callback($args) {
            ?>


            <div class="imgdis" id="logodisplay">

                <img src="<?php echo get_option('pps_form_logo') ?>" width="200" />

            </div>

            <input type="hidden" value="<?php echo get_option('pps_form_logo') ?>" name="pps_form_logo" id="pps_logo_url" class="login_title">
            <input onClick="pps_logo_image()"   type="button" name="upload-btn" id="logo-upload-btn" class="button-secondary" value="Upload">
            <p class="description pps_form_logo"> <?php echo $args[0] ?> </p>



            <?php
        } // end pps_form_logo_callback


        function pps_form_text_callback($args) {

            $content = get_option('pps_form_text');
            $editor_id = 'pps_form_text';
            $settings = array(
                'tinymce' => true,
                'textarea_rows' => 7,
                'quicktags' => array('buttons' => 'em,strong,link',),
                'quicktags' => true,
                'tinymce' => true,
            );

            wp_editor($content, $editor_id, $settings);

            ?>

            <p class="description pps_form_text"> <?php echo $args[0] ?> </p>

            <?php
        } // end pps_form_text_callback



		function pps_form_background_opacity_callback($args) {  
		    ?>
		    
		    <input type="text" class="login_title" name="pps_form_background_opacity" id="pps_form_background_opacity" value="<?php echo get_option('pps_form_background_opacity') ?>" />
		    <p class="description pps_form_background_opacity"> <?php echo $args[0] ?> </p>
		   
		    <?php      
		} // end pps_form_background_opacity_callback



		


		function pps_allowed_ips_callback($args) {  
		    ?>
		    <input type="text" id="pps_allowed_ips" class="login_title2" name="pps_allowed_ips" value="<?php echo get_option('pps_allowed_ips') ?>">
		    <p class="description pps_allowed_ips"> <?php echo $args[0] ?> </p>
		    <?php      
		} // end pps_allowed_ips_callback 


		function pps_goolge_callback($args) {  
		    ?>
		    <select id="pps_goolge" class="login_title" name="pps_goolge">
		    	<option value="yes" <?php echo selected('yes', get_option('pps_goolge')); ?>><?php _e('Yes', 'addify_pps'); ?></option>
		    	<option value="no" <?php echo selected('no', get_option('pps_goolge')); ?>><?php _e('No', 'addify_pps'); ?></option>
		    </select>
		    <p class="description pps_goolge"> <?php echo $args[0] ?> </p>
		    <?php      
		} // end pps_goolge_callback

        function pps_full_hide_products_callback($args) {
            ?>
            <input type="checkbox" name="pps_full_hide_products" value="yes" id="pps_full_hide_products" <?php echo checked('yes', get_option('pps_full_hide_products')); ?> />
            <p class="description pps_full_hide_products"> <?php echo $args[0] ?> </p>
            <?php
        } // end pps_full_hide_products_callback



		function add_rule() {

			global $wpdb;
			
			if(isset($_POST['pps_rule_name']) && $_POST['pps_rule_name']!='') {
				$rule_name = $_POST['pps_rule_name'];
			} else {
				$rule_name = '';
			}

			if(isset($_POST['pps_rule_status']) && $_POST['pps_rule_status']!='') {
				$rule_status = $_POST['pps_rule_status'];
			} else {
				$rule_status = '';
			}

			if(isset($_POST['pps_applied_to']) && $_POST['pps_applied_to']!='') {
				$applied_to = $_POST['pps_applied_to'];
			} else {
				$applied_to = '';
			}


			if(isset($_POST['pps_privatize_products']) && $_POST['pps_privatize_products']!='') {
				$products = $_POST['pps_privatize_products'];
			} else {
				$products = '';
			}


			if(isset($_POST['pps_privatize_categories']) && $_POST['pps_privatize_categories']!='') {
				$categories = $_POST['pps_privatize_categories'];
			} else {
				$categories = '';
			}


			if(isset($_POST['pps_privatize_pages']) && $_POST['pps_privatize_pages']!='') {
				$pages = $_POST['pps_privatize_pages'];
			} else {
				$pages = '';
			}


			$wpdb->query($wpdb->prepare(
				"INSERT INTO ".$wpdb->prefix . "pps_password_rules
				(rule_name, rule_status, applied_to, product_ids, category_ids, page_ids) 
				VALUES(%s, %s, %s, %s, %s, %s)", 
				$rule_name, 
				$rule_status,
				$applied_to,
				serialize($products),
				serialize($categories),
				serialize($pages)
			) );

			
		
			

			


			echo '<div id="message" class="updated notice notice-success is-dismissible"><p>Rule added successfully!</p></div>';


		}


		function update_rule() {

			global $wpdb;

			$rule_id = $_POST['r_id'];
			
			if(isset($_POST['pps_rule_name']) && $_POST['pps_rule_name']!='') {
				$rule_name = $_POST['pps_rule_name'];
			} else {
				$rule_name = '';
			}

			if(isset($_POST['pps_rule_status']) && $_POST['pps_rule_status']!='') {
				$rule_status = $_POST['pps_rule_status'];
			} else {
				$rule_status = '';
			}

			if(isset($_POST['pps_applied_to']) && $_POST['pps_applied_to']!='') {
				$applied_to = $_POST['pps_applied_to'];
			} else {
				$applied_to = '';
			}


			if(isset($_POST['pps_privatize_products']) && $_POST['pps_privatize_products']!='') {
				$products = $_POST['pps_privatize_products'];
			} else {
				$products = '';
			}


			if(isset($_POST['pps_privatize_categories']) && $_POST['pps_privatize_categories']!='') {
				$categories = $_POST['pps_privatize_categories'];
			} else {
				$categories = '';
			}


			if(isset($_POST['pps_privatize_pages']) && $_POST['pps_privatize_pages']!='') {
				$pages = $_POST['pps_privatize_pages'];
			} else {
				$pages = '';
			}


			$wpdb->query($wpdb->prepare( 
				            "
			    UPDATE " .$wpdb->prefix . "pps_password_rules SET rule_name = %s, rule_status = %s, applied_to = %s, product_ids = %s, category_ids = %s, page_ids = %s  WHERE rule_id = %d
			    ",
			    $rule_name,
			    $rule_status,
			    $applied_to,
			    serialize($products),
				serialize($categories),
				serialize($pages),
			    intval($rule_id)
			));

			echo '<div id="message" class="updated notice notice-success is-dismissible"><p>Rule updated successfully!</p></div>';



			

		}


		function add_passwords() {

			global $wpdb;
			$rule_id = $_POST['prule_id'];
			$pass = explode(',', $_POST['passwords']);
			

			for($a = 0; $a<=sizeof($pass)-1; $a++) {

				$result = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM ".$wpdb->prefix."pps_passwords WHERE  password = %s AND rule_id = %d", $pass[$a], $rule_id));

				if(empty($result)) {    

					$wpdb->query($wpdb->prepare("INSERT INTO ".$wpdb->prefix . "pps_passwords(password,rule_id) VALUES(%s, %d)", $pass[$a], $rule_id ) );
				}
			}


			echo '<div id="message" class="updated notice notice-success is-dismissible"><p>Passwords added successfully!</p></div>';


		}


		function imp_passwords() {

			global $wpdb;

			$rule_id = $_POST['prule_id'];

			$filename=$_FILES["importFile"]["tmp_name"];	

			$allowed = array('text/csv');

			if(in_array($_FILES['importFile']['type'], $allowed)){


				 if($_FILES["importFile"]["size"] > 0) {
				  	$file = fopen($filename, "r");
			        while (($getData = fgetcsv($file, 10000, ",")) !== FALSE) {


			        	$result = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM ".$wpdb->prefix."pps_passwords WHERE  password = %s AND rule_id = %d", $getData[0], $rule_id));

						if(empty($result)) {    

							$wpdb->query($wpdb->prepare("INSERT INTO ".$wpdb->prefix . "pps_passwords(password,rule_id) VALUES(%s, %d)", $getData[0],  $rule_id ) );
						}
			           
			         }
					
			         fclose($file);	


			         echo '<div id="message" class="updated notice notice-success is-dismissible"><p>Passwords imported successfully!</p></div>';
				 }
			} else{

				echo '<div id="message" class="updated notice error is-dismissible"><p>Invalid file type. Please upload CSV file that have file extension ".csv"!</p></div>';

			}


			

		}


		


	}

	new Admin_Class_Addify_Password_Protected_Store();

}