<?php session_start(); 
if ( ! defined( 'ABSPATH' ) ) { 
	exit; // restict for direct access
}

if ( !class_exists( 'Front_Class_Addify_Password_Protected_Store' ) ) {

	class Front_Class_Addify_Password_Protected_Store extends Addify_Password_Protected_Store {

		function __construct() {

			//session_unset();
			//echo $_SESSION['pps_unlock_rule'];
			//echo $_SESSION['pps_unlock_password'];

			//600 sec (10 minutes)
			$inactive = 600;
			if( !isset($_SESSION['timeout']) )
			$_SESSION['timeout'] = time() + $inactive; 

			$session_life = time() - $_SESSION['timeout'];

			if($session_life > $inactive) {  
				unset($_SESSION["pps_unlock_rule"]);
				unset($_SESSION["pps_unlock_password"]);
			}

			$_SESSION['timeout']=time();

			$g_boots = get_option('pps_goolge');
			//pps_privatize = get_option('pps_privatize');

			$all_rules = $this->get_all_rules();

			add_action( 'woocommerce_thankyou', array($this, 'pps_checkout_save_user_meta'));


			if($_SERVER['HTTP_USER_AGENT'] == 'googlebot' && $g_boots == 'yes') {

			} else {

				foreach($all_rules as $rule) {


					if($rule->applied_to == 'whole_website') {

						add_action( 'wp', array($this, 'pps_redirect_wholesite' ));
						add_filter( 'page_template', array($this, 'af_pps_account_page_template' ));

					} else if($rule->applied_to == 'selected_items')  {
						add_action('init',array($this, 'pps_remove_add_to_cart_button'));
						add_action('woocommerce_after_shop_loop_item',array($this, 'pps_replace_add_to_cart_button'));

						
						add_filter( 'page_template', array($this, 'af_pps_account_page_template' ));


						add_action( 'wp', array($this, 'pps_redirect_single_product_page' ));
                        if(get_option('pps_full_hide_products') == 'yes') {
                            add_action('woocommerce_product_query', array($this, 'custom_pre_get_posts_query'));
                        }
					} else {

					}


				}

				
			}

			
		}


		function custom_pre_get_posts_query( $q ) {

	    	global $product, $wpdb;
	    	$all_rules = $this->get_all_rules();

			$pripros = array();
			$pricats = array();
			foreach($all_rules as $rule) {

				$pripros = unserialize($rule->product_ids);

				if(!empty($pripros)) {
					foreach($pripros as $pripro) {

						$pri_pros[] = $pripro;
					}
				}


				$pricats = unserialize($rule->category_ids);

				if(!empty($pricats)){
					foreach($pricats as $pricat) {

						$pri_cats[] = $pricat;
					}
				} else {
                    $pri_cats = array();
                }
			}

			if(!empty($_SESSION['pps_unlock_rule'])) {
					$res = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM ".$wpdb->prefix."pps_password_rules WHERE rule_id = %d", $_SESSION['pps_unlock_rule']));
			} else {
				$res = array();
			}

			if(!empty($res->product_ids)) {
				$rpri_pros = unserialize($res->product_ids);
			} else {
				$rpri_pros = array();
			}

			if(!empty($res->category_ids)) {
				$rpri_cats = unserialize($res->category_ids);
			} else {
				$rpri_cats = array();
			}
			$ip_list = get_option('pps_allowed_ips');
			$ip_array = explode(',', $ip_list);
			$my_ip = $_SERVER['REMOTE_ADDR'];


			if(!empty($rpri_cats)) {

                $new_array = array_diff($pri_cats, $rpri_cats);
			    $p_cats = $new_array;
            } else {

                $p_cats = $pri_cats;
            }
			if(!in_array($my_ip, $ip_array)) {



			    if(!empty($pri_pros)) {

                    $q->set( 'post__not_in', (array) $pri_pros );
                }

			    $tax_query = (array) $q->get( 'tax_query' );

			    $tax_query[] = array(
			           'taxonomy' => 'product_cat',
			           'field' => 'id',
			           'terms'     => $p_cats, // Don't display products in the clothing category on the shop page.
			           'operator' => 'NOT IN'
			    );


			    $q->set( 'tax_query', $tax_query );
			}

		}


		function get_all_rules() {

			global $wpdb;
            $results = $wpdb->get_results( $wpdb->prepare( "SELECT * FROM ".$wpdb->prefix."pps_password_rules WHERE rule_status = %s", 'Enabled'));

            return $results;
		}


		function pps_redirect_wholesite() { 

			error_reporting(0);
			global $wp_query, $wpdb;

			$all_rules = $this->get_all_rules();

			
				
			foreach($all_rules as $rule) {

				if(!empty($_SESSION['pps_unlock_rule'])) {
					$res = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM ".$wpdb->prefix."pps_password_rules WHERE rule_id = %d", $_SESSION['pps_unlock_rule']));
				}

	     		$post_obj = $wp_query->get_queried_object();
	     		$Page_ID = $post_obj->post_name;

				$ip_list = get_option('pps_allowed_ips');
				$ip_array = explode(',', $ip_list);
				$my_ip = $_SERVER['REMOTE_ADDR'];
				//$pps_password = get_option('pps_password'); 
				//$pps_password = $this->get_passwords(); 
				$redirect_url =  get_permalink( get_page_by_path( 'pps-password-form' ) );
				

				if(($Page_ID!='pps-password-form') && !in_array($my_ip, $ip_array) && (empty($_SESSION['pps_unlock_password']) && $res->applied_to != 'whole_website')) {
					wp_redirect($redirect_url); 
					exit();
					
				}

			}
		}


		function af_pps_account_page_template($page_template) { 

			$m_account =  get_page_by_path( 'pps-password-form' );
				if ( is_page( $m_account )) {

		        $page_template = addify_pps_plugindir . 'templates/password_form.php';
		        
		    }

		    return $page_template;
		    
		}


		function pps_remove_add_to_cart_button() {
	    	remove_action( 'woocommerce_after_shop_loop_item', 'woocommerce_template_loop_add_to_cart', 10 );
	    }
		
		function pps_replace_add_to_cart_button() {

			global $product, $wpdb;
			$all_rules = $this->get_all_rules();

			$pripros = array();
			$pricats = array();
			foreach($all_rules as $rule) {

				//$pripros = unserialize($rule->product_ids);

				if(!empty($rule->product_ids)) {
					$pripros = unserialize($rule->product_ids);
				} else {
					$pripros = array();
				}

				foreach($pripros as $pripro) {

					$pri_pros[] = $pripro;
				}


				if(!empty($rule->category_ids)) {
					$pricats = unserialize($rule->category_ids);
				} else {
					$pricats = array();
				}
				//$pricats = unserialize($rule->category_ids);

				foreach($pricats as $pricat) {

					$pri_cats[] = $pricat;
				}
			}

			if(!empty($_SESSION['pps_unlock_rule'])) {
					$res = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM ".$wpdb->prefix."pps_password_rules WHERE rule_id = %d", $_SESSION['pps_unlock_rule']));
			}

			

			if(!empty($res->product_ids)) {
				$rpri_pros = unserialize($res->product_ids);
			} else {
				$rpri_pros = array();
			}

			

			if(!empty($res->category_ids)) {
				$rpri_cats = unserialize($res->category_ids);
			} else {
				$rpri_cats = array();
			}
			
			

				//Category Products
				
				$rargs = array(
				    'posts_per_page' => -1,
				    'post_type' => 'product',
				    'post_stats' => 'publish',
				    'tax_query'     => array(
				        array(
				            'taxonomy'  => 'product_cat',
				            'field'     => 'id', 
				            'terms'     => $rpri_cats
				        )
				    )
				);
			    $rproducts_ids = get_posts($rargs);

			    if(empty($rpri_pros)) {
			    	$rpri_pros = array();	
			    }

				foreach($rproducts_ids as $rproid) {
					$rpri_pros[] .= $rproid->ID;
				}

				



			$product_type = $product->get_type();
			$ip_list = get_option('pps_allowed_ips');
			$ip_array = explode(',', $ip_list);
			$my_ip = $_SERVER['REMOTE_ADDR'];
			//$pps_password = get_option('pps_password');
			//$pps_password = $this->get_passwords(); 

			//Category Products
			
			$args = array(
			    'posts_per_page' => -1,
			    'post_type' => 'product',
			    'post_stats' => 'publish',
			    'tax_query'     => array(
			        array(
			            'taxonomy'  => 'product_cat',
			            'field'     => 'id', 
			            'terms'     => $pri_cats
			        )
			    )
			);
		    $products_ids = get_posts($args);

		    if(empty($pri_pros)) {
			    	$pri_pros = array();	
			    }

			foreach($products_ids as $proid) {
				$pri_pros[] .= $proid->ID;
			}

			

				if((in_array($product->get_id(), $pri_pros)) && (!in_array($my_ip, $ip_array)) && (empty($_SESSION['pps_unlock_password']) || !in_array($product->get_id(), $rpri_pros))) {

					
						echo apply_filters( 'woocommerce_loop_add_to_cart_link',
					    sprintf( '<a href="%s" rel="nofollow" data-product_id="%s" data-product_sku="%s" class="button %s product_type_%s">%s</a>',
					        esc_url( get_permalink( $product->get_id() )),
					        esc_attr( '' ),
					        esc_attr( '' ),
					        $product->is_purchasable() ? 'add_to_cart_button' : '',
					        esc_attr( $product_type ),
					        esc_html( 'Password Protected' )
					    ),
						$product );
					
				


					
				} else {

					
					
						switch ( $product_type ) {
							case 'external':
								echo apply_filters( 'woocommerce_loop_add_to_cart_link',
							    sprintf( '<a href="%s" rel="nofollow" data-product_id="%s" data-product_sku="%s" class="button %s product_type_%s">%s</a>',
							        esc_url( $product->add_to_cart_url() ),
							        esc_attr( $product->get_id() ),
							        esc_attr( $product->get_sku() ),
							        $product->is_purchasable() ? 'add_to_cart_button' : '',
							        esc_attr( $product_type ),
							        esc_html( $product->add_to_cart_text() )
							    ),
								$product );
							break;
							case 'grouped':
								echo apply_filters( 'woocommerce_loop_add_to_cart_link',
							    sprintf( '<a href="%s" rel="nofollow" data-product_id="%s" data-product_sku="%s" class="button %s product_type_%s">%s</a>',
							        esc_url( $product->add_to_cart_url() ),
							        esc_attr( $product->get_id() ),
							        esc_attr( $product->get_sku() ),
							        $product->is_purchasable() ? 'add_to_cart_button' : '',
							        esc_attr( $product_type ),
							        esc_html( $product->add_to_cart_text() )
							    ),
								$product );
							break;
							case 'simple':
								echo apply_filters( 'woocommerce_loop_add_to_cart_link',
							    sprintf( '<a href="%s" rel="nofollow" data-product_id="%s" data-product_sku="%s" class="button %s product_type_%s">%s</a>',
							        esc_url( $product->add_to_cart_url() ),
							        esc_attr( $product->get_id() ),
							        esc_attr( $product->get_sku() ),
							        $product->is_purchasable() ? 'add_to_cart_button' : '',
							        esc_attr( $product_type ),
							        esc_html( $product->add_to_cart_text() )
							    ),
								$product );
							break;
							case 'variable':
								echo apply_filters( 'woocommerce_loop_add_to_cart_link',
							    sprintf( '<a href="%s" rel="nofollow" data-product_id="%s" data-product_sku="%s" class="button %s product_type_%s">%s</a>',
							        esc_url( $product->add_to_cart_url() ),
							        esc_attr( $product->get_id() ),
							        esc_attr( $product->get_sku() ),
							        $product->is_purchasable() ? 'add_to_cart_button' : '',
							        esc_attr( $product_type ),
							        esc_html( $product->add_to_cart_text() )
							    ),
								$product );
							break;
							default:
								echo apply_filters( 'woocommerce_loop_add_to_cart_link',
							    sprintf( '<a href="%s" rel="nofollow" data-product_id="%s" data-product_sku="%s" class="button %s product_type_%s">%s</a>',
							        esc_url( $product->add_to_cart_url() ),
							        esc_attr( $product->get_id() ),
							        esc_attr( $product->get_sku() ),
							        $product->is_purchasable() ? 'add_to_cart_button' : '',
							        esc_attr( $product_type ),
							        esc_html( $product->add_to_cart_text() )
							    ),
								$product );
						}
					
				

				

			}





		}


		



		function pps_redirect_single_product_page() {

			error_reporting(0);
			global $post, $wp_query, $wpdb;

			if(is_shop()){
			    $page_id = wc_get_page_id('shop');
			 }

			 $pagee_id = $wp_query->post->ID;

			$all_rules = $this->get_all_rules();

			
				
			foreach($all_rules as $rule) {

				if(!empty($_SESSION['pps_unlock_rule'])) {
					$res = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM ".$wpdb->prefix."pps_password_rules WHERE rule_id = %d", $_SESSION['pps_unlock_rule']));
				} else {
					$res = array();
				}

				

				$cat_obj = $wp_query->get_queried_object();

				if($cat_obj)    {
				    $category_ID  = $cat_obj->term_id;
				}

				if(!empty($rule->product_ids)) {
					$pri_pros = unserialize($rule->product_ids);
				} else {
					$pri_pros = array();
				}
				
				if(!empty($rule->category_ids)) {
					$pri_cats = unserialize($rule->category_ids);
				} else {
					$pri_cats = array();
				}
				
				if(!empty($rule->page_ids)) {
					$pri_pages = unserialize($rule->page_ids);
				} else {
					$pri_pages = array();
				}
				

				if(!empty($res->product_ids)) {

					$rpri_pros = unserialize($res->product_ids);	
				} else {
					$rpri_pros = array();
				}
				
				if(!empty($res->category_ids)) {
					$rpri_cats = unserialize($res->category_ids);
				} else {
					$rpri_cats = array();
				}
				
				if(!empty($res->page_ids)) {
					$rpri_pages = unserialize($res->page_ids);
				}  else {
					$rpri_pages = array();
				}
				

				//Category Products
				$rproductids = array();
				$rargs = array(
				    'posts_per_page' => -1,
				    'post_type' => 'product',
				    'post_stats' => 'publish',
				    'tax_query'     => array(
				        array(
				            'taxonomy'  => 'product_cat',
				            'field'     => 'id', 
				            'terms'     => $rpri_cats
				        )
				    )
				);
			    $rproducts_ids = get_posts($rargs);

			    if(empty($rpri_pros)) {
			    	$rpri_pros = array();	
			    }
			    

				foreach($rproducts_ids as $rproid) {
					$rpri_pros[] .= $rproid->ID;
				}

				$ip_list = get_option('pps_allowed_ips');
				$ip_array = explode(',', $ip_list);
				$my_ip = $_SERVER['REMOTE_ADDR'];
				//$pps_password = get_option('pps_password'); 
				//$pps_password = $this->get_passwords(); 

				//Category Products
				$product_ids = array();
				$args = array(
				    'posts_per_page' => -1,
				    'post_type' => 'product',
				    'post_stats' => 'publish',
				    'tax_query'     => array(
				        array(
				            'taxonomy'  => 'product_cat',
				            'field'     => 'id', 
				            'terms'     => $pri_cats
				        )
				    )
				);
			    $products_ids = get_posts($args);

			    if(empty($pri_pros)) {
			    	$pri_pros = array();	
			    }
			    

				foreach($products_ids as $proid) {
					$pri_pros[] .= $proid->ID;
				}


				if(is_product() && (in_array($post->ID, $pri_pros)) && (!in_array($my_ip, $ip_array))  && (empty($_SESSION['pps_unlock_password']) || !in_array($post->ID, $rpri_pros))) {
			        
			            wp_redirect( get_permalink( get_page_by_path( 'pps-password-form' ) ).'?p_id='.$post->ID );
			        
			    }

			    if((in_array($category_ID, $pri_cats)) && (!in_array($my_ip, $ip_array))  && (empty($_SESSION['pps_unlock_password']) || !in_array($category_ID, $rpri_cats))) {
			        
			            wp_redirect( get_permalink( get_page_by_path( 'pps-password-form' ) ).'?c_id='.$category_ID);
			        
			    }

			    if(is_shop()){

			    	if((in_array($page_id, $pri_pages)) && (!in_array($my_ip, $ip_array))  && (empty($_SESSION['pps_unlock_password']) || !in_array($page_id, $rpri_pages))) {
			        
				           wp_redirect( get_permalink( get_page_by_path( 'pps-password-form' ) ).'?pa_id='.$page_id  );
				       
				        
				    }
			    }

		    	

	    		if((in_array($pagee_id, $pri_pages)) && (!in_array($my_ip, $ip_array))  && (empty($_SESSION['pps_unlock_password']) || !in_array($pagee_id, $rpri_pages))) {


			        
			        wp_redirect( get_permalink( get_page_by_path( 'pps-password-form' ) ).'?pa_id='.$post->ID );
			       
			        
			    }
	    	

			    	
				

			}
		}




		function pps_checkout_save_user_meta($order_id) {  

			$order = wc_get_order( $order_id );
			$order_data = $order->get_data();

			global $wpdb;
			$result = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM ".$wpdb->prefix."pps_password_order WHERE  order_id = %d", $order_id));
			$result2 = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM ".$wpdb->prefix."pps_passwords WHERE  password = %s", $_SESSION['pps_unlock_password']));
			if(empty($result)) {   

				foreach ($order->get_items() as $item_key => $item_values) { 
					$wpdb->query($wpdb->prepare(
						"INSERT INTO ".$wpdb->prefix . "pps_password_order(
						password_id,
						order_id,
						product_name,
						purchased_quantity,
						price_total,
						customer_name,
						email,
						date_purchased
					) 
					VALUES(%d, %d, %s, %s, %s, %s, %s, %s)", 
					$result2->p_id, 
					$order_id,
					$item_values->get_name(),
					$item_values->get_quantity(),
					$item_values->get_total().' '.$order_data['currency'],
					$order_data['billing']['first_name'].' '.$order_data['billing']['last_name'],
					$order_data['billing']['email'],
					$order_data['date_created']->date('d-m-Y H:i:s')

					) );
				}
			}

		}


		




	}

	new Front_Class_Addify_Password_Protected_Store();
}